diff --git a/include/sway/input/cursor.h b/include/sway/input/cursor.h
index 4c130fafc1..f17bed4826 100644
--- a/include/sway/input/cursor.h
+++ b/include/sway/input/cursor.h
@@ -110,7 +110,7 @@ void cursor_set_image_surface(struct sway_cursor *cursor,
 		struct wl_client *client);
 
 void cursor_warp_to_container(struct sway_cursor *cursor,
-	struct sway_container *container);
+	struct sway_container *container, bool force);
 
 void cursor_warp_to_workspace(struct sway_cursor *cursor,
 		struct sway_workspace *workspace);
diff --git a/sway/commands/focus.c b/sway/commands/focus.c
index 56c3d981cb..79b7aed548 100644
--- a/sway/commands/focus.c
+++ b/sway/commands/focus.c
@@ -268,7 +268,16 @@ static struct cmd_results *focus_mode(struct sway_workspace *ws,
 	}
 	if (new_focus) {
 		seat_set_focus_container(seat, new_focus);
-		seat_consider_warp_to_focus(seat);
+
+		// If we're on the floating layer and the floating container area
+		// overlaps the position on the tiling layer that would be warped to,
+		// `seat_consider_warp_to_focus` would decide not to warp, but we need
+		// to anyway.
+		if (config->mouse_warping == WARP_CONTAINER) {
+			cursor_warp_to_container(seat->cursor, new_focus, true);
+		} else {
+			seat_consider_warp_to_focus(seat);
+		}
 	} else {
 		return cmd_results_new(CMD_FAILURE,
 				"Failed to find a %s container in workspace",
diff --git a/sway/input/cursor.c b/sway/input/cursor.c
index e47410a5a9..52b6287292 100644
--- a/sway/input/cursor.c
+++ b/sway/input/cursor.c
@@ -1115,18 +1115,19 @@ struct sway_cursor *sway_cursor_create(struct sway_seat *seat) {
 
 /**
  * Warps the cursor to the middle of the container argument.
- * Does nothing if the cursor is already inside the container.
- * If container is NULL, returns without doing anything.
+ * Does nothing if the cursor is already inside the container and `force` is
+ * false. If container is NULL, returns without doing anything.
  */
 void cursor_warp_to_container(struct sway_cursor *cursor,
-		struct sway_container *container) {
+		struct sway_container *container, bool force) {
 	if (!container) {
 		return;
 	}
 
 	struct wlr_box box;
 	container_get_box(container, &box);
-	if (wlr_box_contains_point(&box, cursor->cursor->x, cursor->cursor->y)) {
+	if (!force && wlr_box_contains_point(&box, cursor->cursor->x,
+			cursor->cursor->y)) {
 		return;
 	}
 
diff --git a/sway/input/seat.c b/sway/input/seat.c
index 04b480d8e0..cace059bd3 100644
--- a/sway/input/seat.c
+++ b/sway/input/seat.c
@@ -1469,15 +1469,15 @@ void seat_consider_warp_to_focus(struct sway_seat *seat) {
 		if (output) {
 			struct wlr_box box;
 			output_get_box(output, &box);
-			if (wlr_box_contains_point(&box,
-						seat->cursor->cursor->x, seat->cursor->cursor->y)) {
+			if (wlr_box_contains_point(&box, seat->cursor->cursor->x,
+						seat->cursor->cursor->y)) {
 				return;
 			}
 		}
 	}
 
 	if (focus->type == N_CONTAINER) {
-		cursor_warp_to_container(seat->cursor, focus->sway_container);
+		cursor_warp_to_container(seat->cursor, focus->sway_container, false);
 	} else {
 		cursor_warp_to_workspace(seat->cursor, focus->sway_workspace);
 	}
